require 'cicd/builder/chefrepo'

module CiCd
  module Builder
    _lib=File.dirname(__FILE__)
    $:.unshift(_lib) unless $:.include?(_lib)

    require 'cicd/builder/manifest/version'

    module Manifest
      CLASS = 'CiCd::Builder::Manifest'
      class Runner < ChefRepo::Runner
        require 'cicd/builder/manifest/mixlib/build'
        require 'cicd/builder/manifest/mixlib/repo'
        include CiCd::Builder::Manifest::Build
        include CiCd::Builder::Manifest::Repo

        # ---------------------------------------------------------------------------------------------------------------
        def initialize()
          super
          @default_options[:builder] = VERSION
        end

        # ---------------------------------------------------------------------------------------------------------------
        def getBuilderVersion
          {
              version:  VERSION,
              major:    MAJOR,
              minor:    MINOR,
              patch:    PATCH,
          }
        end

        # ---------------------------------------------------------------------------------------------------------------
        def setup()
          $stdout.write("ManifestBuilder v#{CiCd::Builder::Manifest::VERSION}\n")
          @default_options[:env_keys] << %w(
                                            MANIFEST_FILE
                                            CLASSES_FILE
                                            CLASSES_MANIFEST_FILE
                                           )
          super
        end

      end
    end

  end
end
